import java.util.*;

public class node{

public Vector<node> incoming;
public Vector<node> outgoing;
public Vector<node> outgoingInhib;
public String name;
public int subclass=0;//there is no need to define a subclass!

public node(String name, int capacity){
this.name=name;
incoming=new Vector<node>(capacity);
outgoing=new Vector<node>(capacity);
outgoingInhib=new Vector<node>(capacity);
}

public node(String name){
this(name,10);
}

public boolean equals(node what){
  return (what.name==this.name);
}

public void linkto(node what,boolean inhibitory){
if(inhibitory)
  this.outgoingInhib.add(what);
this.outgoing.add(what);
what.addIncoming(this);
}

public void linkto(node what){
linkto(what,false);
}

public void addIncoming(node what){
this.incoming.add(what);
}

//adds uo the number of all outgoing links this node has within its subclass
public int countWithinSubclassEdges(){
int sum=0;
for (node current: outgoing)
  if(current.subclass==this.subclass)
    sum++;
return sum;
}

public void printConnections(){
for (node current: outgoing)
  System.out.println("("+this.name+","+current.name+")");
}

public void printOutgoing(node inputToThis){
  if(outgoing.contains(inputToThis))
    System.out.print(" 1");
  else
    System.out.print(" 0");
}

public int isOutgoing(node inputToThis){
return isOutgoing(inputToThis,false);
}

public int isOutgoing(node inputToThis,boolean considerInhibitory){
  if((considerInhibitory)&&(outgoingInhib.contains(inputToThis)))
    return -1;
  if(outgoing.contains(inputToThis))
    return 1;
  else
    return 0;
}

} 
